



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android Touch事件传递机制 二：单纯的（伪生命周期）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android Touch事件传递机制 二：单纯的（伪生命周期）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 07:29:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转载于：<a href="http://blog.csdn.net/yuanzeyao/article/details/38025165" rel="external nofollow noreferrer">http://blog.csdn.net/yuanzeyao/article/details/38025165</a></p>
<p>在前一篇文章中，我主要讲解了<a href="http://lib.csdn.net/base/15" rel="external nofollow noreferrer">Android</a>源码中的Touch事件的传递过程，现在我想使用一个demo以及一个实例来学习一下Andorid中的Touch事件处理过程。</p>
<p>在Android系统中，和Touch事件分发和处理紧密相关的三个函数如下：<br />(1) public boolean dispatchTouchEvent(MotionEvent ev)<br />(2) public boolean onInterceptTouchEvent(MotionEvent ev)//这个方法在一个事件周期（down,move,up）内只要onInterceptTouchEvent（down/move（up已经是最后一次不算）只要拦截了一次）或onTouchEvent（中的ACTION_DOWN）有一个返回true，就不会再走第二次。<br />(3) public boolean onTouchEvent(MotionEvent event)</p>
<p>这三个方法我在前一篇文章中都对他们的源码进行了分析：方法1主要是对Touch事件进行分发，方法2主要是对Touch事件进行拦截，方法3是对Touch事件进行处理</p>
<p>这三个方法主要存在于ViewGroup,View,Activity中，具体情况如下图：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>ViewGroup</td>
<td>View</td>
<td>&nbsp;Activity</td>
</tr>
<tr>
<td>dispatchTouchEvent</td>
<td>有</td>
<td>有</td>
<td>有</td>
</tr>
<tr>
<td>onInterceptTouchEvent</td>
<td>有</td>
<td>无</td>
<td>无</td>
</tr>
<tr>
<td>onTouchEvent</td>
<td>有</td>
<td>有</td>
<td>有</td>
</tr>
</tbody>
</table>
<p>下面我们就使用一个demo来看看这些方法的执行流程：<br />自定义一个类：MyLayoutFirst.java</p>
<div>
<ol><li>public&nbsp;class&nbsp;MyLayoutFirst&nbsp;extends&nbsp;LinearLayout</li>
<li>{</li>
<li>private&nbsp;static&nbsp;final&nbsp;String&nbsp;TAG&nbsp;=&nbsp;"MyLayoutFirst";</li>
<li>public&nbsp;MyLayoutFirst(Context&nbsp;context,&nbsp;AttributeSet&nbsp;attrs)</li>
<li>{</li>
<li>super(context,&nbsp;attrs);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;onInterceptTouchEvent(MotionEvent&nbsp;ev)</li>
<li>{</li>
<li>Log.w("yzy",&nbsp;"MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;"+MyUtils.getActionName(ev));</li>
<li>return&nbsp;super.onInterceptTouchEvent(ev);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;onTouchEvent(MotionEvent&nbsp;event)</li>
<li>{</li>
<li>Log.e("yzy",&nbsp;"MyLayoutFirst-&gt;onTouchEvent-&gt;"+MyUtils.getActionName(event));</li>
<li>return&nbsp;super.onTouchEvent(event);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;dispatchTouchEvent(MotionEvent&nbsp;ev)</li>
<li>{</li>
<li>Log.i("yzy",&nbsp;"MyLayoutFirst-&gt;dispatchTouchEvent-&gt;"+MyUtils.getActionName(ev));</li>
<li>return&nbsp;super.dispatchTouchEvent(ev);</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>自定义一个类；MyLayoutSecond.java</p>
<div>
<ol><li>public&nbsp;class&nbsp;MyLayoutSecond&nbsp;extends&nbsp;LinearLayout</li>
<li>{</li>
<li>private&nbsp;static&nbsp;final&nbsp;String&nbsp;TAG&nbsp;=&nbsp;"MyLayoutSecond";</li>
<li>public&nbsp;MyLayoutSecond(Context&nbsp;context,&nbsp;AttributeSet&nbsp;attrs)</li>
<li>{</li>
<li>super(context,&nbsp;attrs);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;onTouchEvent(MotionEvent&nbsp;event)</li>
<li>{</li>
<li>Log.e("yzy",&nbsp;"MyLayoutSecond-&gt;MyLayoutSecond-&gt;"+MyUtils.getActionName(event));</li>
<li>return&nbsp;super.onTouchEvent(event);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;onInterceptTouchEvent(MotionEvent&nbsp;ev)</li>
<li>{</li>
<li>Log.w("yzy",&nbsp;"MyLayoutSecond-&gt;onInterceptTouchEvent-&gt;"+MyUtils.getActionName(ev));</li>
<li>return&nbsp;super.onInterceptTouchEvent(ev);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;dispatchTouchEvent(MotionEvent&nbsp;ev)</li>
<li>{</li>
<li>Log.i("yzy",&nbsp;"MyLayoutSecond-&gt;dispatchTouchEvent-&gt;"+MyUtils.getActionName(ev));</li>
<li>return&nbsp;super.dispatchTouchEvent(ev);</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>加入到main_layout.xml中</p>
<div>
<ol><li>&lt;RelativeLayout&nbsp;xmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>xmlns:tools="http://schemas.android.com/tools"</li>
<li>android:layout_width="match_parent"</li>
<li>android:layout_height="match_parent"</li>
<li>&gt;</li>
<li>&lt;com.event.demo.MyLayoutFirst</li>
<li>android:id="@+id/layout_first"</li>
<li>android:layout_width="match_parent"</li>
<li>android:layout_height="match_parent"</li>
<li>android:background="#FF0000"</li>
<li>&gt;</li>
<li>&lt;com.event.demo.MyLayoutSecond</li>
<li>android:id="@+id/layout_second"</li>
<li>android:layout_width="320dip"</li>
<li>android:layout_height="120dip"</li>
<li>android:layout_gravity="center"</li>
<li>android:background="#0000FF"</li>
<li>&gt;</li>
<li>&lt;/com.event.demo.MyLayoutSecond&gt;</li>
<li>&lt;/com.event.demo.MyLayoutFirst&gt;</li>
<li>&lt;/RelativeLayout&gt;</li></ol>
</div>
<p>MainActivity中加入onTouchEvent方法</p>
<div>
<ol><li>public&nbsp;class&nbsp;MainActivity&nbsp;extends&nbsp;Activity</li>
<li>{</li>
<li>@Override</li>
<li>protected&nbsp;void&nbsp;onCreate(Bundle&nbsp;savedInstanceState)</li>
<li>{</li>
<li>super.onCreate(savedInstanceState);</li>
<li>setContentView(R.layout.activity_main);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;onCreateOptionsMenu(Menu&nbsp;menu)</li>
<li>{</li>
<li>//&nbsp;Inflate&nbsp;the&nbsp;menu;&nbsp;this&nbsp;adds&nbsp;items&nbsp;to&nbsp;the&nbsp;action&nbsp;bar&nbsp;if&nbsp;it&nbsp;is&nbsp;present.</li>
<li>getMenuInflater().inflate(R.menu.main,&nbsp;menu);</li>
<li>return&nbsp;true;</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;dispatchTouchEvent(MotionEvent&nbsp;ev)</li>
<li>{</li>
<li>Log.i("yzy",&nbsp;"MainActivity-&gt;dispatchTouchEvent-&gt;"+MyUtils.getActionName(ev));</li>
<li>return&nbsp;super.dispatchTouchEvent(ev);</li>
<li>}</li>
<li>@Override</li>
<li>public&nbsp;boolean&nbsp;onTouchEvent(MotionEvent&nbsp;event)</li>
<li>{</li>
<li>Log.e("yzy",&nbsp;"MainActivity-&gt;onTouchEvent-&gt;"+MyUtils.getActionName(event));</li>
<li>return&nbsp;super.onTouchEvent(event);</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>最后就一个工具类，用来将事件id转换为字符串。</p>
<div>
<ol><li>public&nbsp;class&nbsp;MyUtils</li>
<li>{</li>
<li>private&nbsp;static&nbsp;final&nbsp;String&nbsp;TAG&nbsp;=&nbsp;"MyUtils";</li>
<li>public&nbsp;static&nbsp;String&nbsp;getActionName(MotionEvent&nbsp;event)</li>
<li>{</li>
<li>String&nbsp;name="";</li>
<li>switch(event.getAction())</li>
<li>{</li>
<li>case&nbsp;MotionEvent.ACTION_DOWN:</li>
<li>name="ACTION_DOWN";</li>
<li>break;</li>
<li>case&nbsp;MotionEvent.ACTION_MOVE:</li>
<li>name="ACTION_MOVE";</li>
<li>break;</li>
<li>case&nbsp;MotionEvent.ACTION_UP:</li>
<li>name="ACTION_UP";</li>
<li>break;</li>
<li>}</li>
<li>return&nbsp;name;</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>运行效果如图：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140721223223828?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveXVhbnpleWFv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>第一中情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
<td>
<p>super.onTouchEven</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果：</p>
<p>其中蓝色部分是MyLayoutSecond.<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a>&nbsp;，红色部分是MyLayoutFirst.java<br />现在我点击一下蓝色部分：运行结果如图：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140721223312078?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveXVhbnpleWFv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>从图中可以看出，事件最先被Activity捕获，然后分发给 MyLayoutFirst，MyLayoutFirst首先调用自身的onInterceptTouchEvent判断是否将该事件拦截，由于默认返回是false,所以没有拦截，从而事件分发给了MyLayoutSecond,MyLayoutSecond同样通过dispatchTouchEvent分发出去，分发出去之前同样检查是否被拦截，默认都是没有被拦截的，但是由于MyLayoutSecond是没有子视图的，所有最终事件有自己处理，调用自身的onTouchEvent方法，由于该方法默认返回的是false,所以认为此事件是没有被消费掉的，继续传递到了MyLayoutFirst中，同样也没有消费这个事件，最终传递到了Mainactivity,继续往后看发现后面的ACTION_MOVE和ACTION_UP并没有传入MyLayoutFirst和MyLayoutSecond,这是因为一旦某一个事件没有被处理，后面的事件是不会被分发的。所以ACTION_MOVE和ACTION_UP直接被MainActivity处理掉了。</p>
<p>下面再看第二种情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>true</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140721223722832?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveXVhbnpleWFv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>从图中可以看出，事件传递到了MyLayoutFirst后没有分发到MyLayoutSecond，直接调用自身的onTouchEvent,由于返回的是false,导致事件没有消费，最终传递给了MainActivity,<br />而且后续事件也没有传递到MyLayoutFirst和MyLayoutSecond，直接被MainActivity处理</p>
<p>第三种情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>true</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
<td>
<p>true</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140721223820646?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveXVhbnpleWFv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>和情况二不同的是MyLayoutFirst的onTouchEvent返回了true，也就是说MyLayoutFirst消费了此事件，所以ACTION_DOWN也没有再传给MainActivity,并且ACTION_MOVE和ACTION_UP<br />均传给了MyLayoutFirst</p>
<p>第四中情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent</p>
</td>
<td>
<p>super.onTouchEvent</p>
</td>
<td>
<p>super.onTouchEven</p>
</td>
<td>
<p>true</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140721223622593?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQveXVhbnpleWFv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>发现所有的事件都是传递到了MyLayoutSecond后被消费了</p>
<p>第五种情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent down</p>
<p>　　　　　　　　　　　 move</p>
<p>　　　　　　　　　　　　up</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent down</p>
<p>　　　　　　　　　　　 move</p>
<p>　　　　　　　　　　　　up</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>false</p>
<p>true/false</p>
<p>false</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
<p>super.onInterceptTouchEvent(ev)</p>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent 　　　down</p>
<p>　　　　　　　　　　　move</p>
<p>　　　　　　　　　　　up</p>
</td>
<td>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
</td>
<td>
<p>true</p>
<p>super.onTouchEven</p>
<p>super.onTouchEven</p>
</td>
<td>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent表示false</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果：</p>
<p>08-12 10:20:10.592: I/yzy(28806): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 10:20:10.602: I/yzy(28806): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 10:20:10.602: W/yzy(28806): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_DOWN<br />08-12 10:20:10.612: I/yzy(28806): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 10:20:10.612: W/yzy(28806): MyLayoutSecond-&gt;onInterceptTouchEvent-&gt;ACTION_DOWN<br />08-12 10:20:10.622: E/yzy(28806): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_DOWN<br />08-12 10:20:10.622: E/yzy(28806): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_DOWN<br />08-12 10:20:10.692: I/yzy(28806): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.702: I/yzy(28806): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.702: E/yzy(28806): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.702: E/yzy(28806): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.712: I/yzy(28806): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.712: I/yzy(28806): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.722: E/yzy(28806): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.722: E/yzy(28806): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 10:20:10.732: I/yzy(28806): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 10:20:10.732: I/yzy(28806): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 10:20:10.742: E/yzy(28806): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_UP<br />08-12 10:20:10.742: E/yzy(28806): MainActivity-&gt;onTouchEvent-&gt;ACTION_UP</p>
<p>这种情况表明，只要一个ViewGrounp在onTouchEvent的ACTION_DOWN中消费了事件，那么不论这个ViewGrounp的onTouchEvent的ACTION_MOVE，ACTION_UP中返回true(消费事件，事件结束)还是false（事件上传），事件都会传到这个ViewGrounp得onTouchEvent中（前提是没有被在前面就拦截掉），而且这个ViewGrounp得onInterceptTouchEvent也不会再走</p>
<p>第六种情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent down</p>
<p>　　　　　　　　　　　 move</p>
<p>　　　　　　　　　　　　up</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent down</p>
<p>　　　　　　　　　　　 move</p>
<p>　　　　　　　　　　　　up</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>false</p>
<p>false</p>
<p>false</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
<p>super.onInterceptTouchEvent(ev)</p>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent 　　　down</p>
<p>　　　　　　　　　　　move</p>
<p>　　　　　　　　　　　up</p>
</td>
<td>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
</td>
<td>
<p>true</p>
<p>true</p>
<p>true</p>
</td>
<td>
<p>true</p>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent表示false</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果：</p>
<p>08-12 11:24:24.992: I/yzy(15159): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 11:24:25.002: I/yzy(15159): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 11:24:25.002: W/yzy(15159): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_DOWN<br />08-12 11:24:25.012: I/yzy(15159): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 11:24:25.012: W/yzy(15159): MyLayoutSecond-&gt;onInterceptTouchEvent-&gt;ACTION_DOWN<br />08-12 11:24:25.022: E/yzy(15159): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_DOWN<br />08-12 11:24:25.032: I/yzy(15159): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.032: I/yzy(15159): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.042: W/yzy(15159): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.042: I/yzy(15159): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.052: E/yzy(15159): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_MOVE<br />08-12 11:24:25.052: E/yzy(15159): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.092: I/yzy(15159): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.092: I/yzy(15159): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.092: W/yzy(15159): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.092: I/yzy(15159): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.102: E/yzy(15159): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_MOVE<br />08-12 11:24:25.102: E/yzy(15159): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.132: I/yzy(15159): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.132: I/yzy(15159): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.132: W/yzy(15159): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.142: I/yzy(15159): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.142: E/yzy(15159): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_MOVE<br />08-12 11:24:25.142: E/yzy(15159): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:24:25.152: I/yzy(15159): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 11:24:25.152: I/yzy(15159): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 11:24:25.162: W/yzy(15159): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_UP<br />08-12 11:24:25.162: I/yzy(15159): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 11:24:25.162: E/yzy(15159): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_UP<br />08-12 11:24:25.172: E/yzy(15159): MainActivity-&gt;onTouchEvent-&gt;ACTION_UP</p>
<p>当一个ViewGrounp在onTouchEvent的ACTION_DOWN中消费了事件，但是在它的onTouchEvent的ACTION_MOVE，ACTION_UP中返回false的话，虽然事件还是会传递到它的onTouchEvent中，但是它却会从它自己的onTouchEvent直接上传回Activity的onTouchEvent中，中间不会经过其他的ViewGrounp</p>
<p>第七种情况：</p>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>
<p>MainActivity</p>
</td>
<td>
<p>MyLayoutFirst</p>
</td>
<td>
<p>MyLayoutSecond</p>
</td>
</tr>
<tr>
<td>
<p>dispatchTouchEvent down</p>
<p>　　　　　　　　　　　 move</p>
<p>　　　　　　　　　　　　up</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
<td>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
<p>super.dispatchTouchEvent</p>
</td>
</tr>
<tr>
<td>
<p>onInterceptTouchEvent down</p>
<p>　　　　　　　　　　　 move</p>
<p>　　　　　　　　　　　　up</p>
</td>
<td>
<p>--</p>
</td>
<td>
<p>false</p>
<p>true</p>
<p>false</p>
</td>
<td>
<p>super.onInterceptTouchEvent(ev)</p>
<p>super.onInterceptTouchEvent(ev)</p>
<p>super.onInterceptTouchEvent(ev)</p>
</td>
</tr>
<tr>
<td>
<p>onTouchEvent 　　　down</p>
<p>　　　　　　　　　　　move</p>
<p>　　　　　　　　　　　up</p>
</td>
<td>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent</p>
</td>
<td>
<p>true</p>
<p>false</p>
<p>false</p>
</td>
<td>
<p>true</p>
<p>super.onTouchEvent</p>
<p>super.onTouchEvent表示false</p>
</td>
</tr>
</tbody>
</table>
<p>运行结果：</p>
<p>08-12 11:34:54.897: I/yzy(18093): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 11:34:54.897: I/yzy(18093): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 11:34:54.917: W/yzy(18093): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_DOWN<br />08-12 11:34:54.937: I/yzy(18093): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;ACTION_DOWN<br />08-12 11:34:54.947: W/yzy(18093): MyLayoutSecond-&gt;onInterceptTouchEvent-&gt;ACTION_DOWN<br />08-12 11:34:54.957: E/yzy(18093): MyLayoutSecond-&gt;MyLayoutSecond-&gt;ACTION_DOWN<br />08-12 11:34:54.967: I/yzy(18093): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:54.967: I/yzy(18093): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:54.977: W/yzy(18093): MyLayoutFirst-&gt;onInterceptTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:54.977: I/yzy(18093): MyLayoutSecond-&gt;dispatchTouchEvent-&gt;<br />08-12 11:34:54.977: E/yzy(18093): MyLayoutSecond-&gt;MyLayoutSecond-&gt;<br />08-12 11:34:54.977: E/yzy(18093): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.017: I/yzy(18093): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.027: I/yzy(18093): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.027: E/yzy(18093): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.037: E/yzy(18093): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.047: I/yzy(18093): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.057: I/yzy(18093): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.067: E/yzy(18093): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.067: E/yzy(18093): MainActivity-&gt;onTouchEvent-&gt;ACTION_MOVE<br />08-12 11:34:55.077: I/yzy(18093): MainActivity-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 11:34:55.087: I/yzy(18093): MyLayoutFirst-&gt;dispatchTouchEvent-&gt;ACTION_UP<br />08-12 11:34:55.087: E/yzy(18093): MyLayoutFirst-&gt;onTouchEvent-&gt;ACTION_UP<br />08-12 11:34:55.097: E/yzy(18093): MainActivity-&gt;onTouchEvent-&gt;ACTION_UP</p>
<p>MyLayoutSecond的onTouchEvent的ACTION_DOWN中消费了事件，所以事件会默认往他那儿传递，但是被MyLayoutFirst的onInterceptTouchEvent在ACTION_MOVE给半路拦截<br />导致后续操作都被拦截传递给MyLayoutFirst的onTouchEvent（但由于其没有消费事件，所以会往上传）</p>
<p>其实还有很多其他组合方式，大家如果又兴趣可以自己尝试改变每个函数的返回值，查看打印结果，这里我就不一一列举了。。。。。</p>
<p>最后我会提供一个小demo演示如何解决滑动冲突，背景如下：<br />一个ViewPager里面包含两个Framgent,有一个Fragment里面有一个HorizontalListView ，如何滑动冲突？<br />我就贴出关键代码吧</p>
<p>[java] view plain copy</p>
<p>print?<br />horizontal=(HorizontalListView)view.findViewById(R.id.hscroll);  <br />    horizontal.setOnTouchListener(new OnTouchListener()  <br />    {</p>
<p>@Override  <br />      public boolean onTouch(View arg0, MotionEvent event)  <br />      {  <br />        if(event.getAction()==MotionEvent.ACTION_DOWN)  <br />        {  <br />          parent.requestDisallowInterceptTouchEvent(true);  <br />        }else if(event.getAction()==MotionEvent.ACTION_UP)  <br />        {  <br />          parent.requestDisallowInterceptTouchEvent(false);  <br />        }  <br />        return false;  <br />      }  <br />    });</p>
<p>加入这段代码就可以避免滑动冲突了，至于为什么大家可以参考我的前以前文章《Android Touch 事件传递机制详解 上》 这两个demo的例子我均会上传下载的</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9po5ykq.html">Android Studio 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyp6djq.html">FFmpeg Filters Images 参数及效果图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv2evxq.html">javascript 与和非</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7md0lgq.html">work-10</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zor2mdq.html">利用DIV&plus;CSS制作网页过程中常用的基本概念及标签使用细节</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzl25g8.html">SecureFX 乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpx5kzq.html">王立平--WebView的缓存机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ml1v48.html">JVM之对象的创建简要流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7jm78.html">consistent&period;go 源码阅读</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15jm5q.html">&dollar;Django 聚合函数、分组查询、F&comma;Q查询、orm字段以及参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7yzk8.html">rabbitmq management advance lesson</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j61deq.html">C&num;语言&mdash;&mdash;&mdash;&mdash;第三章   使用属性升级MyBank</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vz20q.html">linux  网卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g6m26q.html">谷歌开源OCR，tesseract-ocr使用笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm0mjg9.html">【codevs1959】拔河比赛</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjejyo8.html">wifidog交叉编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk3w418.html">ElasticSearch Aggs的一些使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p3nl5q.html">&lbrack;BZOJ4028&rsqb;&lbrack;HAOI2015&rsqb;公约数数列&lbrack;分块&plus;分析暴力&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2keykxq.html">剑指offer&lowbar;面试题5&lowbar;从尾到头打印链表（栈和递归实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvnmo2q.html">LeetCode&mdash;&mdash;Basic Calculator</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqv275o9.html">String&comma;StringBuffer与StringBuilder的区别&quest;&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqllxpeq.html">jquery ajax（实现单独提交某个form）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9604rj9.html">Android音频开发之AudioTrack实时播放</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93wklgq.html">通过setTimeout来取消因大量计算造成的网页卡顿</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdjdd9.html">php使用post方式获得文件扩展名</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnv6nk8.html">Java 理论与实践&colon; 正确使用 Volatile 变量--转</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kj66j9.html">利用SkyDrive Pro 迅速批量下载SharePoint Server 上已上传的文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r5ppmq.html">Xen之初体验：XenMotion、 StorageMotion、Site Recovery、Power Management 各种新、高级功能免费</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdgxj9.html">重温JSP学习笔记--JSTL标签库</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2wgj9.html">C&num;创建安全的字典&lpar;Dictionary&rpar;存储结构</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
